%define with_tests 0

Name:          openjpa
Version:       2.0.0
%define subrel 1
Release:       %mkrel 1
Summary:       Java Persistence 2.0 API (JPA) 
Group:         Development/Java
License:       ASL 2.0
Url:           http://openjpa.apache.org/
Source0:       http://archive.apache.org/dist/openjpa/2.0.0/apache-openjpa-2.0.0-source.zip
Source1:       openjpa-2.0.0-autogeneratedfiles.tar.gz
# remove org.codehaus.mojo ianal-maven-plugin 1.0-alpha-1 and fix apache-rat-plugin version/group
Patch0:        openjpa-2.0.0-pom_xml.patch
# remove om.agilejava.docbkx docbkx-maven-plugin 2.0.7 com.sun jai_core jai_codec 1.1.3 runtime
Patch1:        openjpa-2.0.0-project-pom_xml.patch

Patch2:        openjpa-2.0.0-checkstyle-plugin-pom_xml.patch
# remove com.ibm.websphere websphere_uow_api 0.0.1
Patch3:        openjpa-2.0.0-kernel-pom_xml.patch

Patch4:        openjpa-2.0.0-persistence-jdbc-DynamicEnhancementSuite.patch

Patch5:	       openjpa-2.0.0-CVE-2013-1768.patch

BuildRequires: jpackage-utils
BuildRequires: java-devel

BuildRequires: ant
BuildRequires: ant-jsch
BuildRequires: apache-commons-collections
BuildRequires: apache-commons-dbcp
BuildRequires: apache-commons-lang
BuildRequires: apache-commons-logging
BuildRequires: apache-commons-pool
BuildRequires: derby
BuildRequires: felix-osgi-core
BuildRequires: geronimo-jms
BuildRequires: geronimo-jpa-2.0-api
BuildRequires: geronimo-jta
BuildRequires: geronimo-validation-1.0-api
BuildRequires: glassfish-jaf
BuildRequires: glassfish-jaxb
BuildRequires: glassfish-jaxb-api
BuildRequires: glassfish-stax-api
BuildRequires: hsqldb
BuildRequires: jmock2
BuildRequires: junit
BuildRequires: liblog4j-java
BuildRequires: postgresql-jdbc
BuildRequires: regexp
BuildRequires: serp
BuildRequires: simple-jndi
BuildRequires: forge-parent

#BuildRequires: jtds
BuildRequires: mysql-connector-java

BuildRequires: apache-rat-plugin
BuildRequires: javacc-maven-plugin
BuildRequires: maven
BuildRequires: maven-antrun-plugin
BuildRequires: maven-assembly-plugin
BuildRequires: maven-checkstyle-plugin
BuildRequires: maven-compiler-plugin
BuildRequires: maven-enforcer-plugin
BuildRequires: maven-gpg-plugin
BuildRequires: maven-jar-plugin
BuildRequires: maven-javadoc-plugin
BuildRequires: maven-plugin-bundle
BuildRequires: maven-project-info-reports-plugin
BuildRequires: maven-release-plugin
BuildRequires: maven-remote-resources-plugin
BuildRequires: maven-resources-plugin
BuildRequires: maven-shade-plugin
BuildRequires: maven-site-plugin
BuildRequires: maven-source-plugin
BuildRequires: maven-surefire-plugin
BuildRequires: maven-ant-plugin
BuildRequires: taglist-maven-plugin
BuildRequires: plexus-velocity
BuildRequires: mvn(org.apache.maven.shared:maven-osgi)
Buildrequires: apache-resource-bundles

Requires:      ant
Requires:      apache-commons-collections
Requires:      apache-commons-dbcp
Requires:      apache-commons-lang
Requires:      apache-commons-logging
Requires:      apache-commons-pool
Requires:      derby
Requires:      felix-osgi-core
Requires:      geronimo-jms
Requires:      geronimo-jpa-2.0-api
Requires:      geronimo-jta
Requires:      geronimo-validation-1.0-api
Requires:      glassfish-jaf
Requires:      glassfish-jaxb
Requires:      glassfish-jaxb-api
Requires:      glassfish-stax-api
Requires:      hsqldb
Requires:      jmock2
Requires:      liblog4j-java
Requires:      postgresql-jdbc
Requires:      regexp
Requires:      serp
Requires:      simple-jndi


Requires:      jpackage-utils
Requires(post): jpackage-utils
Requires(postun): jpackage-utils
Requires:      java
BuildArch:     noarch

%description
OpenJPA is Apache's implementation of Sun's Java Persistence 2.0 API (JSR-317
JPA 2.0) specification for the transparent persistence of Java objects.
.
It is an object-relational mapping (ORM) solution for the Java language,
which simplifies storing objects in databases.

%package javadoc
Summary:       API documentation for %{name}
Group:         Development/Java
Requires:      jpackage-utils

%description javadoc
This package contains Maven plugin for %{name}

%prep
%setup -q -n apache-openjpa-%{version}-source

for j in $(find . -name "*.jar"); do
   mv $j $j.no
done

for d in BUILDING CHANGES LICENSE NOTICE README ; do
  iconv -f iso8859-1 -t utf-8 $d.txt > $d.txt.conv && mv -f $d.txt.conv $d.txt
  sed -i 's/\r//' $d.txt
done

%patch0 -p0
%patch1 -p0
%patch2 -p0

for p in $(find . -name "pom.xml"); do
   sed -i "s|<groupId>ant</groupId>|<groupId>org.apache.ant</groupId>|" $p
   sed -i "s|pom.version|project.version|" $p
   sed -i 's|${artifactId}|${project.artifactId}|' $p
   sed -i 's|${groupId}|${project.groupId}|' $p
done

%patch3 -p0
# addTestSuite(java.lang.Class<? extends junit.framework.TestCase>) in junit.framework.TestSuite cannot be applied to (java.lang.Class<capture#170 of ?>)
%patch4 -p0
%patch5 -p3

sed -i "s|<groupId>org.osgi</groupId>|<groupId>org.apache.felix</groupId>|" openjpa-persistence/pom.xml
sed -i "s|<version>4.2.0</version>|<version>1.4.0</version>|" openjpa-persistence/pom.xml

sed -i "s|<module>openjpa-integration</module>|<!--module>openjpa-integration</module-->|" pom.xml

# disable requires com.agimatec agimatec-validation 0.9.6 test com.agimatec agimatec-jsr303 0.9.6 test org.codehaus.mojo openjpa-maven-plugin 1.1
#sed -i "s|<module>daytrader</module>|<!--module>daytrader</module-->|" openjpa-integration/pom.xml
#sed -i "s|<module>validation</module>|<!--module>validation</module-->|" openjpa-integration/pom.xml

# require com.ibm.websphere websphere_uow_api 0.0.1
rm -rf openjpa-kernel/src/main/java/org/apache/openjpa/kernel/jpql/ParseException.java
rm -rf openjpa-kernel/src/main/java/org/apache/openjpa/ee/WASRegistryManagedRuntime.java
rm -rf openjpa-kernel/src/main/java/org/apache/openjpa/ee/AutomaticManagedRuntime.java

%build

mvn-rpmbuild -e \
%if %{with_tests}
  -P test-derby \
%else
  -Dtest=false \
%endif
  -DfailIfNoTests=false \
  -Dmaven.test.failure.ignore=true \
  ant:ant install javadoc:aggregate process-resources

%install
[ %{buildroot} != / ] && rm -rf %{buildroot}


mkdir -p %{buildroot}%{_javadir}/%{name}

# Spring BR
install -pm 644 openjpa/target/openjpa-%{version}.jar %{buildroot}%{_javadir}/%{name}
install -pm 644 openjpa-all/target/openjpa-all-%{version}.jar %{buildroot}%{_javadir}/%{name}

install -pm 644 openjpa-examples/target/openjpa-examples-%{version}.jar %{buildroot}%{_javadir}/%{name}

#install -pm 644 openjpa-jdbc/target/openjpa-jdbc-%{version}-tests.jar %{buildroot}%{_javadir}/%{name}/openjpa-jdbc-tests-%{version}.jar
install -pm 644 openjpa-jdbc/target/openjpa-jdbc-%{version}.jar %{buildroot}%{_javadir}/%{name}

#install -pm 644 openjpa-kernel/target/openjpa-kernel-%{version}-tests.jar %{buildroot}%{_javadir}/%{name}/openjpa-kernel-tests-%{version}.jar
install -pm 644 openjpa-kernel/target/openjpa-kernel-%{version}.jar %{buildroot}%{_javadir}/%{name}

#install -pm 644 openjpa-lib/target/openjpa-lib-%{version}-tests.jar %{buildroot}%{_javadir}/%{name}/openjpa-lib-tests-%{version}.jar
install -pm 644 openjpa-lib/target/openjpa-lib-%{version}.jar %{buildroot}%{_javadir}/%{name}

#install -pm 644 openjpa-persistence/target/openjpa-persistence-%{version}-tests.jar %{buildroot}%{_javadir}/%{name}/openjpa-persistence-tests-%{version}.jar
install -pm 644 openjpa-persistence/target/openjpa-persistence-%{version}.jar %{buildroot}%{_javadir}/%{name}

#install -pm 644 openjpa-persistence-jdbc/target/openjpa-persistence-jdbc-%{version}-tests.jar \
#  %{buildroot}%{_javadir}/%{name}/openjpa-persistence-jdbc-tests-%{version}.jar
install -pm 644 openjpa-persistence-jdbc/target/openjpa-persistence-jdbc-%{version}.jar %{buildroot}%{_javadir}/%{name}

#install -pm 644 openjpa-persistence-locking/target/openjpa-persistence-locking-%{version}-tests.jar \
#  %{buildroot}%{_javadir}/%{name}/openjpa-persistence-locking-tests-%{version}.jar
install -pm 644 openjpa-persistence-locking/target/openjpa-persistence-locking-%{version}.jar %{buildroot}%{_javadir}/%{name}

#install -pm 644 openjpa-slice/target/openjpa-slice-%{version}-tests.jar %{buildroot}%{_javadir}/%{name}/openjpa-slice-tests-%{version}.jar
install -pm 644 openjpa-slice/target/openjpa-slice-%{version}.jar %{buildroot}%{_javadir}/%{name}

install -pm 644 openjpa-xmlstore/target/openjpa-xmlstore-%{version}.jar %{buildroot}%{_javadir}/%{name}

(
  cd %{buildroot}%{_javadir}/%{name}
  for jar in *-%{version}.jar; do
    ln -sf ${jar} `echo $jar| sed "s|-%{version}||g"`
  done
)

mkdir -p %{buildroot}%{_mavenpomdir}
install -pm 644 pom.xml %{buildroot}%{_mavenpomdir}/JPP.%{name}-%{name}-parent.pom
%add_maven_depmap JPP.%{name}-%{name}-parent.pom
install -pm 644 openjpa-project/pom.xml %{buildroot}%{_mavenpomdir}/JPP.%{name}-apache-%{name}.pom
%add_maven_depmap JPP.%{name}-apache-%{name}.pom
install -pm 644 openjpa/pom.xml %{buildroot}%{_mavenpomdir}/JPP.%{name}-%{name}.pom
%add_maven_depmap JPP.%{name}-%{name}.pom %{name}/%{name}.jar
install -pm 644 openjpa-all/pom.xml %{buildroot}%{_mavenpomdir}/JPP.%{name}-%{name}-all.pom
%add_maven_depmap JPP.%{name}-%{name}-all.pom %{name}/%{name}-all.jar
install -pm 644 openjpa-examples/pom.xml %{buildroot}%{_mavenpomdir}/JPP.%{name}-%{name}-examples.pom
%add_maven_depmap JPP.%{name}-%{name}-examples.pom %{name}/%{name}-examples.jar
#install -pm 644 openjpa-integration/pom.xml %{buildroot}%{_mavenpomdir}/JPP.%{name}-%{name}-integration.pom
#dd_maven_depmap JPP.%{name}-%{name}-integration.pom
#install -pm 644 openjpa-integration/tck/pom.xml %{buildroot}%{_mavenpomdir}/JPP.%{name}-%{name}-integration-tck.pom
#dd_maven_depmap JPP.%{name}-%{name}-integration-tck.pom
#install -pm 644 openjpa-integration/examples/pom.xml %{buildroot}%{_mavenpomdir}/JPP.%{name}-%{name}-integration-examples.pom
#dd_maven_depmap JPP.%{name}-%{name}-integration-examples.pom
install -pm 644 openjpa-jdbc/pom.xml %{buildroot}%{_mavenpomdir}/JPP.%{name}-%{name}-jdbc.pom
%add_maven_depmap JPP.%{name}-%{name}-jdbc.pom %{name}/%{name}-jdbc.jar
install -pm 644 openjpa-kernel/pom.xml %{buildroot}%{_mavenpomdir}/JPP.%{name}-%{name}-kernel.pom
%add_maven_depmap JPP.%{name}-%{name}-kernel.pom %{name}/%{name}-kernel.jar
install -pm 644 openjpa-lib/pom.xml %{buildroot}%{_mavenpomdir}/JPP.%{name}-%{name}-lib.pom
%add_maven_depmap JPP.%{name}-%{name}-lib.pom %{name}/%{name}-lib.jar
install -pm 644 openjpa-persistence/pom.xml %{buildroot}%{_mavenpomdir}/JPP.%{name}-%{name}-persistence.pom
%add_maven_depmap JPP.%{name}-%{name}-persistence.pom %{name}/%{name}-persistence.jar
install -pm 644 openjpa-persistence-jdbc/pom.xml %{buildroot}%{_mavenpomdir}/JPP.%{name}-%{name}-persistence-jdbc.pom
%add_maven_depmap JPP.%{name}-%{name}-persistence-jdbc.pom %{name}/%{name}-persistence-jdbc.jar
install -pm 644 openjpa-persistence-locking/pom.xml %{buildroot}%{_mavenpomdir}/JPP.%{name}-%{name}-persistence-locking.pom
%add_maven_depmap JPP.%{name}-%{name}-persistence-locking.pom %{name}/%{name}-persistence-locking.jar
install -pm 644 openjpa-slice/pom.xml %{buildroot}%{_mavenpomdir}/JPP.%{name}-%{name}-slice.pom
%add_maven_depmap JPP.%{name}-%{name}-slice.pom %{name}/%{name}-slice.jar
install -pm 644 openjpa-xmlstore/pom.xml %{buildroot}%{_mavenpomdir}/JPP.%{name}-%{name}-xmlstore.pom
%add_maven_depmap JPP.%{name}-%{name}-xmlstore.pom %{name}/%{name}-xmlstore.jar


mkdir -p %{buildroot}%{_javadocdir}/%{name}
cp -pr target/site/apidocs/* %{buildroot}%{_javadocdir}/%{name}

%clean
[ %{buildroot} != / ] && rm -rf %{buildroot}

%post
%update_maven_depmap

%postun
%update_maven_depmap

%files
%{_javadir}/%{name}/%{name}-%{version}.jar
%{_javadir}/%{name}/%{name}.jar
%{_javadir}/%{name}/%{name}-all-%{version}.jar
%{_javadir}/%{name}/%{name}-all.jar
%{_javadir}/%{name}/%{name}-examples-%{version}.jar
%{_javadir}/%{name}/%{name}-examples.jar
%{_javadir}/%{name}/%{name}-jdbc-%{version}.jar
%{_javadir}/%{name}/%{name}-jdbc.jar
%{_javadir}/%{name}/%{name}-kernel-%{version}.jar
%{_javadir}/%{name}/%{name}-kernel.jar
%{_javadir}/%{name}/%{name}-lib-%{version}.jar
%{_javadir}/%{name}/%{name}-lib.jar
%{_javadir}/%{name}/%{name}-persistence-%{version}.jar
%{_javadir}/%{name}/%{name}-persistence-jdbc-%{version}.jar
%{_javadir}/%{name}/%{name}-persistence-jdbc.jar
%{_javadir}/%{name}/%{name}-persistence-locking-%{version}.jar
%{_javadir}/%{name}/%{name}-persistence-locking.jar
%{_javadir}/%{name}/%{name}-persistence.jar
%{_javadir}/%{name}/%{name}-slice-%{version}.jar
%{_javadir}/%{name}/%{name}-slice.jar
%{_javadir}/%{name}/%{name}-xmlstore-%{version}.jar
%{_javadir}/%{name}/%{name}-xmlstore.jar
%{_mavenpomdir}/*
%{_mavendepmapfragdir}/*
%doc BUILDING.txt CHANGES.txt LICENSE.txt  NOTICE.txt README.txt RELEASE-NOTES.html

%files javadoc
%{_javadocdir}/%{name}


%changelog
* Mon Sep 30 2013 luigiwalser <luigiwalser> 2.0.0-1.1.mga2
+ Revision: 489525
- add upstream patch to fix CVE-2013-1768

  + gil <gil>
    - imported package openjpa

